package com.chuanglan.shanyan_sdk_test_demo.view;

import android.annotation.TargetApi;
import android.content.Intent;
import android.os.Build;
import android.support.annotation.NonNull;
import android.support.v7.app.AppCompatActivity;
import android.os.Bundle;
import android.util.Log;
import android.view.View;
import android.widget.Button;

import com.chuanglan.shanyan_sdk.OneKeyLoginManager;
import com.chuanglan.shanyan_sdk.listener.GetPhoneInfoListener;
import com.chuanglan.shanyan_sdk.listener.InitListener;
import com.chuanglan.shanyan_sdk_test_demo.BuildConfig;
import com.chuanglan.shanyan_sdk_test_demo.R;
import com.yanzhenjie.permission.Action;
import com.yanzhenjie.permission.AndPermission;
import com.yanzhenjie.permission.Permission;

import java.util.List;

public class FristActivity extends AppCompatActivity implements View.OnClickListener {

    Button normal, chenjinshi, debug,numberBtn;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_frist);
        initViews();
    }

    private void initViews() {
        normal = findViewById(R.id.normal);
        chenjinshi = findViewById(R.id.chenjinshi);
        debug = findViewById(R.id.debug);
        numberBtn = findViewById(R.id.numberBtn);
        normal.setOnClickListener(this);
        chenjinshi.setOnClickListener(this);
        debug.setOnClickListener(this);
        numberBtn.setOnClickListener(this);
    }

    @Override
    public void onClick(View v) {
        switch (v.getId()) {
            case R.id.normal:
                startNormalModel();
                requestPermission(Permission.READ_PHONE_STATE,"normal");
                break;
            case R.id.chenjinshi:
                startNormalModel();
                requestPermission(Permission.READ_PHONE_STATE,"chenjinshi");
                break;
            case R.id.debug:
                Intent intent = new Intent(FristActivity.this, DebugModeActivity.class);
                startActivity(intent);
                break;
            case R.id.numberBtn:
                startAuthentication();
        }
    }

    private void startAuthentication() {
        OneKeyLoginManager.getInstance().init(getApplicationContext(), BuildConfig.APP_ID, BuildConfig.APP_KEY, new InitListener() {
            @Override
            public void getInitStatus(int code, String result) {
                Log.e("VVV", "初始化code=" + code + "result==" + result);
            }
        });
        //跳转到本机号认证页面
        Intent intent = new Intent(FristActivity.this, AuthenticationActivity.class);
        startActivity(intent);
    }

    private void startNormalModel(){
        OneKeyLoginManager.getInstance().init(getApplicationContext(), BuildConfig.APP_ID, BuildConfig.APP_KEY, new InitListener() {
            @Override
            public void getInitStatus(int code, String result) {
                Log.e("VVV", "初始化code=" + code + "result==" + result);
                if (code == 1022) {
                    //权限判断：调用网络初始化和预取号前需要获取READ_PHONE_STATE权限，否则会返回失败状态码

                }
            }
        });
    }

    private void requestPermission(String permissions, final String type) {
        AndPermission.with(this)
                .permission(permissions)
                .onGranted(new Action() {
                    @TargetApi(Build.VERSION_CODES.M)
                    @Override
                    public void onAction(List<String> permissions) {
                        //闪验SDK预取号（可选，能加速拉起授权页）
                        OneKeyLoginManager.getInstance().getPhoneInfo(new GetPhoneInfoListener() {
                            @Override
                            public void getPhoneInfoStatus(int code, String result) {
                                Log.e("VVV", "预取号code=" + code + "result=" + result);
                            }
                        });

                        Intent intent = new Intent(FristActivity.this, StartActivity.class);
                        intent.putExtra("type",type);
                        startActivity(intent);
                    }
                })
                .onDenied(new Action() {
                    @Override
                    public void onAction(@NonNull List<String> permissions) {
                        //闪验SDK预取号（可选，能加速拉起授权页）
                        OneKeyLoginManager.getInstance().getPhoneInfo(new GetPhoneInfoListener() {
                            @Override
                            public void getPhoneInfoStatus(int code, String result) {
                                Log.e("VVV", "预取号code=" + code + "result=" + result);
                            }
                        });

                        Intent intent = new Intent(FristActivity.this, StartActivity.class);
                        intent.putExtra("type",type);
                        startActivity(intent);
                    }
                })
                .start();
    }
}
